package gui;

import javax.swing.JTextField;

/**
 * Interface for handlers in a state.
 *
 * @author Tom Verhoeff (TU/e)
 */
public abstract class AbstractState {

    /** The field that this state operates on. */
    protected JTextField field;

    /** Handle event A. */
    public abstract void handleA();

    /** Handle event B. */
    public abstract void handleB();

    /** Handle event C. */
    public abstract void handleC();

    /**
     * Convenience method to increment an integer stored as string.
     *
     * @param s  string to increment
     * @pre {@code s} represents an integer
     * @return  {@code s} incremented by one
     */
    public static String inc(String s) {
        final Integer result = Integer.parseInt(s) + 1;
        return result.toString();

    }

    /**
     * Convenience method to increment a text field.
     *
     * @param field  text field to increment
     * @pre {@code field != null}
     */
    public static void inc(javax.swing.JTextField field) {
        field.setText(inc(field.getText()));
    }

}
